VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "EventHandler"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' The shortcut menus that will be dynamically enabled/disabled/checked
Dim OpenMissingSpec As RoseContextMenuItem

Public Sub OnActivate(RoseApp As RoseApplication)
    'MsgBox "MissingSpecifications Add-in: OnActivate"
    
    'Find add-in
    Dim thisAddIn As RoseAddIn
    Set thisAddIn = RoseApp.AddInManager.AddIns.GetFirst("MissingSpecifications")
    If Not thisAddIn Is Nothing Then
        'MsgBox "MissingSpecifications Add-in found"
        Set OpenMissingSpec = thisAddIn.AddContextMenuItem(rsDefault, "Open Missing Specification", "OpenMissingSpec")
    End If
End Sub

Public Sub OnDeactivate(RoseApp As RoseApplication)
    'MsgBox "MissingSpecifications Add-in: OnDeactivate"
    
    Set OpenMissingSpec = Nothing
End Sub

Public Function OnEnableContextMenuItems(RoseApp As RoseApplication, MenuItem As RoseContextMenuItemType) As Boolean
    'MsgBox "MissingSpecifications Add-in: OnEnableContextMenuItems"
    Dim allSelectedItems As RoseItemCollection
    Set allSelectedItems = RoseApp.CurrentModel.GetSelectedItems()
    
    If allSelectedItems.Count <> 2 Then
        OpenMissingSpec.MenuState = rsDisabled
    Else
        If (allSelectedItems.GetAt(1).IdentifyClass() = "CategoryDependency" And _
           allSelectedItems.GetAt(2).IdentifyClass() = "Category") Or _
           (allSelectedItems.GetAt(1).IdentifyClass() = "Category" And _
           allSelectedItems.GetAt(2).IdentifyClass() = "CategoryDependency") Then
           OpenMissingSpec.MenuState = rsEnabled
        Else
            OpenMissingSpec.MenuState = rsDisabled
        End If
    End If
    
    OnEnableContextMenuItems = True
End Function

Public Function OnSelectedContextMenuItem(RoseApp As RoseApplication, internalName As String) As Boolean
    
    Dim allSelectedItems As RoseItemCollection
    Set allSelectedItems = RoseApp.CurrentModel.GetSelectedItems()
        
    If internalName = "OpenMissingSpec" Then
        Dim theCategoryDependency As RoseCategoryDependency
        If allSelectedItems.GetAt(1).IdentifyClass() = "CategoryDependency" Then
            Set theCategoryDependency = allSelectedItems.GetAt(1)
        ElseIf allSelectedItems.GetAt(2).IdentifyClass() = "CategoryDependency" Then
            Set theCategoryDependency = allSelectedItems.GetAt(2)
        End If
        dlgCategoryDependencySpecification.MyShow theCategoryDependency
    End If
    
    OnSelectedContextMenuItem = True
End Function


